#!/bin/bash

###################################
### Line srch 1=iter		###
###################################
yisdir=/net/server/homes/sep/yishen/seam3D
bindir=${yisdir}/bin
datdir=${yisdir}
shdir=${yisdir}/shScript/bV_bQ_4VQ
iter=${1}
P=${iter}
O=$((${iter}-1))

srch4q=${datdir}/seam2D.bvbq4vq.srch4q.iter${O}.H
grdo4q=${datdir}/seam2D.bvbq4vq.bQ.iter${O}.H
grdp4q=${datdir}/seam2D.bvbq4vq.bQ.iter${P}.H
alfaO4q=${datdir}/seam2D.bvbq4vq.alfa4q.iter${O}.H  
alfaP4q=${datdir}/seam2D.bvbq4vq.alfa4q.iter${P}.H 
 
srch4v=${datdir}/seam2D.bvbq4vq.srch4v.iter${O}.H
grdo4v=${datdir}/seam2D.bvbq4vq.bvel.iter${O}.H
grdp4v=${datdir}/seam2D.bvbq4vq.bvel.iter${P}.H
alfaO4v=${datdir}/seam2D.bvbq4vq.alfa4v.iter${O}.H  
alfaP4v=${datdir}/seam2D.bvbq4vq.alfa4v.iter${P}.H 

fobjO=${datdir}/seam2D.bvbq4vq.fobj.iter${O}.H
fobj=${datdir}/seam2D.bvbq4vq.fobj.iter${P}.H

cd ${yisdir}
for isrch in {1..3} 
do

  echo "Step length in ${isrch} of iteration ${P}"
  #-----------------------------------------------------------------------------------
  #----------- gradient processing: grdp=grdo+isrch*alpha*srch 
  #-----------------------------------------------------------------------------------
  <${grdo4v} ${bindir}/myMPI-srchprcs.x srch=${srch4v}  alpha=${alfaO4v} isrch=${isrch} qmin=1438.44 qmax=2848.28 >${grdp4v} 
  <${grdo4q} ${bindir}/myMPI-srchprcs.x srch=${srch4q}  alpha=${alfaO4q} isrch=${isrch} qmin=1.17758 qmax=4 >${grdp4q} 

  #-----------------------------------------------------------------------------------
  #----------- fobj at each isrch
  #-----------------------------------------------------------------------------------
  ${shdir}/shImg.sh ${P} 3 y
  ${shdir}/shDimgLine4Q.sh ${P} ${isrch}
  ${shdir}/shDimgLine4V.sh ${P} ${isrch}
done
   Cat ${datdir}/seam2D.fobj4q.junk1.H ${datdir}/seam2D.fobj4q.junk2.H ${datdir}/seam2D.fobj4q.junk3.H axis=1>${datdir}/seam2D.fobj4q.junka.H
   Cat ${datdir}/seam2D.fobj4v.junk1.H ${datdir}/seam2D.fobj4v.junk2.H ${datdir}/seam2D.fobj4v.junk3.H axis=1>${datdir}/seam2D.fobj4v.junka.H
   Math file1=${datdir}/seam2D.fobj4v.junka.H file2=${datdir}/seam2D.fobj4q.junka.H exp="file1+file2/200" >${datdir}/seam2D.fobj.junka.H

  #-----------------------------------------------------------------------------------
  #----------- line search
  #-----------------------------------------------------------------------------------

  <${grdo4v} ${bindir}/myMPI-srchstep.x nsrch=${nsrch} alphO=${alfaO4v} alphP=${alfaP4v} fobjP=${datdir}/seam2D.fobj.junka.H fobjO=${fobjO} fobj=${fobj} srch=${srch4v} qmin=1438.44 qmax=2848.28>${grdp4v}

  <${grdo4q} ${bindir}/myMPI-srchstep.x nsrch=${nsrch} alphO=${alfaO4q} alphP=${alfaP4q} fobjP=${datdir}/seam2D.fobj.junka.H fobjO=${fobjO} fobj=${fobj} srch=${srch4q} qmin=1.17758 qmax=4>${grdp4q}




  echo "line srch end" 


