program seam_add_q                
  use sep

  implicit none

  real,dimension(:,:,:),allocatable:: vel,Q, tape, Q1, Q2, Q3
  integer:: n1, n2,n3,i1, i2,i3, x1, x2, y1, y2, z1, z2, tapex, tapey, tapez
  real   :: o1, o2, o3, d1, d2, d3, pi
  real	 :: velrms, minQ3

  call sep_init()

  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  allocate( vel(n1, n2, n3), Q(n1, n2, n3),tape(n1, n2, n3), Q1(n1, n2, n3), Q2(n1, n2, n3), Q3(n1, n2, n3))
  call sep_read(vel)
  
 !x=1200-1900m;  y=600-1000m; z=700-1400m
  x1=60; x2=95; y1=30; y2=50; z1=20; z2=60
  tapex=10; tapey=5; tapez=5;
  pi=3.1415
  Q=50
  velrms=maxval(vel(60:95, 30:50, 35:70))
  tape=1.0



  do i3=z1,z1+tapez
	tape(: ,:, i3)=1.0+cos(pi*(i3-z1)/tapez/2)*(50-30)/50

  end do
  do i3=z2-tapez,z2
	tape(: ,:, i3)=1.0+cos(pi*(i3-z2)/tapez/2)*(50-30)/50
	write(0,*) "tape", tape(1, 1, i3)
  end do





 
  do i1=x1,x2 
    do i2=y1,y2 
	do i3=z1, z2  
	  Q1(i1 ,i2, i3)=1/(vel(i1, i2, i3)**2)*(velrms**2)*30*tape(i1, i2, i3)
	  if (Q1(i1 ,i2 ,i3) .gt. 50) then
  	    Q2(i1 ,i2 ,i3)=50
          end if
	end do
    end do
  end do

  !!! need smooth here~
  Q3=log(Q2)/log(10.0)
  minQ3=minval(Q3)
  do i1=1, n1
  do i2=1, n2
  do i3=1, n3
	Q3(i1,i2,i3)=log(Q2(i1, i2, i3))/log(10.0)
	Q(i1,i2,i3)=(Q3(i1, i2, i3)-minQ3)/(log(50.0)/log(10.0)-minQ3)*4.0
  end do
  end do
  end do

  call to_history("n1",n1)
  call to_history("n2",n2)
  call to_history("n3",n3)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)

  call sep_write(Q)
  deallocate(vel,Q, tape, Q1, Q2, Q3)
  call sep_close()
end program 
