program seam_add_q1                
  use sep

  implicit none

  real,dimension(:,:,:),allocatable:: vel,Q, tape, Q1
  integer:: n1, n2,n3,i1, i2,i3, xa1, xa2, ya1, ya2, za1, za2,xb1, xb2, yb1, yb2, zb1, zb2, tapex, tapey, tapez
  real   :: o1, o2, o3, d1, d2, d3, pi
  real	 :: velrmsa, velrmsb

  call sep_init()

  call from_history("n1",n1)
  call from_history("n2",n2)
  call from_history("n3",n3)
  call from_history("d1",d1)
  call from_history("d2",d2)
  call from_history("d3",d3)
  call from_history("o1",o1)
  call from_history("o2",o2)
  call from_history("o3",o3)
  allocate( vel(n1, n2, n3), Q(n1, n2, n3),tape(n1, n2, n3), Q1(n1, n2, n3))
  call sep_read(vel)
  
 !!xa=1200-1900m;  ya=600-1000m; za=700-1400m
 ! xa1=60; xa2=95; ya1=30; ya2=50; za1=20; za2=60
 !xa=1200-1900m;  ya=1300-1800m; za=500-1000m
  xa1=60; xa2=95; ya1=65; ya2=90; za1=20; za2=55
 !xb=3500-4300m;  yb=1400-1900m; zb=600-1200m
  xb1=175; xb2=215; yb1=70; yb2=95; zb1=25; zb2=60

  tapex=10; tapey=5; tapez=5;
  pi=3.1415
  Q=50
  velrmsa=maxval(vel(xa1:xa2, ya1:ya2, za1:za2))
  velrmsb=maxval(vel(xb1:xb2, yb1:yb2, zb1:zb2))

  

 
  do i1=xa1,xa2 
    do i2=ya1,ya2 
	do i3=za1, za2  
	  !vel1=vel(i1, i2, i3)*((za2-i3+1)/(za2-za1))
	  Q1(i1 ,i2, i3)=(vel(i1, i2, i3)**2)/(velrmsa**2)*15
	  if (Q1(i1 ,i2 ,i3) .gt. 50) then
  	    Q(i1 ,i2 ,i3)=50
	  else
	    Q(i1 ,i2 ,i3)=Q1(i1 ,i2 ,i3)
          end if
	end do
    end do
  end do

  do i1=xb1,xb2 
    do i2=yb1,yb2 
	do i3=zb1, zb2  
	  Q1(i1 ,i2, i3)=(vel(i1, i2, i3)**2)/(velrmsb**2)*15
	  if (Q1(i1 ,i2 ,i3) .gt. 50) then
  	    Q(i1 ,i2 ,i3)=50
	  else
	    Q(i1 ,i2 ,i3)=Q1(i1 ,i2 ,i3)
          end if
	end do
    end do
  end do
  tape=Q
  do i1=xa1, xa2
  do i2=ya1, ya2
  do i3=za1, za1+tapez
	tape(i1,i2, i3)=cos(pi*(i3-za1)/tapez/2)*(50.0-Q(i1, i2, za1+tapez))+Q(i1, i2, za1+tapez)
  end do
  end do
  end do

  do i1=xa1, xa2
  do i2=ya1, ya2
  do i3=za2-tapez,za2
	tape(i1 ,i2, i3)=cos(pi*(i3-za2)/tapez/2)*(50.0-Q(i1, i2, za2-tapez))+Q(i1, i2, za2-tapez)

  end do
  end do
  end do

  do i1=xb1, xb2
  do i2=yb1, yb2
  do i3=zb1,zb1+tapez
	tape(i1 ,i2, i3)=cos(pi*(i3-zb1)/tapez/2)*(50.0-Q(i1, i2, zb1+tapez))+Q(i1, i2, zb1+tapez)

  end do
  end do 
  end do

  do i1=xb1, xb2
  do i2=yb1, yb2
  do i3=zb2-tapez,zb2
	tape(i1 ,i2, i3)=cos(pi*(i3-zb2)/tapez/2)*(50.0-Q(i1, i2, zb2-tapez))+Q(i1, i2, zb2-tapez)
  end do
  end do 
  end do

  write(0,*) "minQ, maxQ",minval(Q),maxval(Q)
  call to_history("n1",n1)
  call to_history("n2",n2)
  call to_history("n3",n3)
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)

  call sep_write(tape)
  deallocate(Q, tape, Q1)
  call sep_close()
end program 
